/*
dttools is Copyright (C) 2002 Douglas Thain
This software is released under the GNU General Public License.
See the file COPYING for details.
*/


#include "pthread_utils.h"

#include <sys/time.h>

int pthread_cond_wait_usec( pthread_cond_t *cond, pthread_mutex_t *mutex, int usec )
{
	struct timeval tv;
	struct timespec ts;

	gettimeofday( &tv, 0 );

	tv.tv_usec += usec;
	while(tv.tv_usec>1000000) {
		tv.tv_usec-=1000000;
		tv.tv_sec+=1;
	}

	ts.tv_sec = tv.tv_sec;
	ts.tv_nsec = tv.tv_usec*1000;

	return pthread_cond_timedwait( cond, mutex, &ts );
}

int pthread_cond_wait_secs( pthread_cond_t *cond, pthread_mutex_t *mutex, int secs )
{
	return pthread_cond_wait_usec(cond,mutex,secs*1000000);
}

